<?php
/**
* JoomBlog Archive Module for Joomla
* @version $Id: helper.php 2011-03-16 17:30:15
* @package JoomBlog
* @subpackage helper.php
* @author JoomPlace Team
* @Copyright Copyright (C) JoomPlace, www.joomplace.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_joomblog'.DS.'router.php');

class modJbArchivePostsHelper
{
	function getList(&$params)
	{
    global $_JB_CONFIGURATION;
	
		$db = &JFactory::getDBO();
		
    $managedSections = $_JB_CONFIGURATION->managedSections;
	
    if(!isset($managedSections)){
      $query = "SELECT value FROM #__joomblog_config WHERE name='all' LIMIT 1 ";
      $db->setQuery($query);
      $config = $db->loadResult();
      eval($config);
    }
    
     $sections = implode(",",jbGetCategoryArray($managedSections));
    
		$where = " AND ( c.catid IN ( ".$sections." ) ) ";
		
		$sql = " 
      SELECT  
        DATE_FORMAT( c.publish_up,'%M') AS monthname,
        MONTH( c.created ) AS created_month, 
        YEAR( c.created ) AS created_year
      FROM #__content AS c
        WHERE c.state = 1 AND c.created < NOW() $where
      GROUP BY created_year DESC, created_month DESC ";
	
	//,  count( c.created ) AS count_month
		$db->setQuery($sql);
		$posts = $db->loadObjectList();
		
		$list = array();
		if($posts){
			foreach($posts as $value){
				if (!isset($value->count_month)) $value->count_month = modJbArchivePostsHelper::getCountByYearAndMonth($value->created_year, $value->created_month);
				$list[$value->created_year]['month'][] = $value;
				@$list[$value->created_year]['count'] += $value->count_month;				
			}
		}
		return $list;
	}
	
	function getCountByYearAndMonth($created_year=0, $created_month=0)
	{
		$user	=& JFactory::getUser();
    	$db	=& JFactory::getDBO();
    	$date	=& JFactory::getDate();
        $sql	= "SELECT a.*, p.posts FROM #__content AS `a` " .
    		 " LEFT JOIN `#__joomblog_privacy` AS `p` ON `p`.`postid`=`a`.`id` AND `p`.`isblog`=0 ".
    		 " WHERE MONTH( a.created )=".$created_month." AND YEAR( a.created )=".$created_year." AND a.`state` != '0' ";
    $db->setQuery($sql);
    $rows = $db->loadObjectList();
	
	if(sizeof($rows))
	{
		for($i = 0; $i < count($rows); $i++ )
		{
			$row = &$rows[$i];
			$db->setQuery(" SELECT b.blog_id as bid, lb.title as btitle, p.posts, p.comments  " .
						      " FROM #__joomblog_blogs as b, #__joomblog_list_blogs as lb " .
						      " LEFT JOIN `#__joomblog_privacy` AS `p` ON `p`.`postid`=`lb`.`id` AND `p`.`isblog`=1 ".
						      " WHERE b.content_id=".$row->id." AND lb.id = b.blog_id AND lb.approved=1 AND lb.published=1 ");
			$blogs = $db->loadObjectList();
			if (sizeof($blogs)) 
				{
				switch ( $blogs[0]->posts ) 
				{
					case 0:	break;
					case 1:	
						if (!$user->id) 
						{
							unset($rows[$i]);
						}
					case 2:	
						if (!$user->id) 
						{
							unset($rows[$i]);
						}else
						{
							if (!isFriends($user->id, $row->created_by) && $user->id!=$row->created_by)
							{
								unset($rows[$i]);
							}	
						}
					break;
					case 3:	
						if (!$user->id) 
						{
								unset($rows[$i]);
						}else
						{
							if ($user->id!=$row->created_by)
							{
								unset($rows[$i]);
							}	
						}						
					break;
				}
			}	
			if (isset($rows[$i]))
			
			
   			 switch ( $row->posts ) 
			{
				case 0: break;
				case 1:	
					if (!$user->id) 
					{
						unset($rows[$i]);
					}
				break;
				case 2:	
					if (!$user->id) 
					{
						unset($rows[$i]);
					}else
					{
						if (!isFriends($user->id, $row->created_by) && $user->id!=$row->created_by)
						{
							unset($rows[$i]);
						} 
					}
				break;
				case 3:	
					if (!$user->id) 
					{
						unset($rows[$i]);
					}else
					{
						if ($user->id!=$row->created_by)
						{
							unset($rows[$i]);
						}
					}						
				break;
		}
		//$rows = array_values($rows);	
	 }
   }
    
    $count	= count($rows);
    return $count;
	}
	
	function getItemid(){
		$Itemid = JRequest::getInt('Itemid');
	
		$menu 	= &JSite::getMenu();
		$items	= $menu->getItems('link', 'index.php?option=com_joomblog&view=default');
		
		return $items?$items[0]->id:$Itemid;
	}
}
